
<div class="row">
 <div class="col-12 d-flex justify-content-between" >
   <a href="/teaching/xml/introduction"class="btn btn-primary" role="button" >Introduction </a> <a href="/teaching"class="btn btn-primary" role="button" >Sommaire </a>  <a href="/teaching/xml/dtd"class="btn btn-primary" role="button" >DTD</a>
 </div>
</div>
<h1><%= title %> </h1>
<hr/>

<h2>Structures</h2>
<hr/>
<p>XML utilise une structure arborescente (de la racine vers les feuilles)
<ul>
 <li>Le document commence à l'élément racine (root).</li>
 <li>Les feuilles continent l'information.</li>
 <li>Les noeuds représente les relations entre les éléments.</li>
 <li>tous les éléments peuvent avoir des sous-éléments.</li>
</ul>
</p>
<img src="/images/courses/XML/xml_schema"width="540px" />
<h2>Entete</h2>
<hr/>
Un document XML commence <b>toujours</b> par cette ligne:
<pre><code>&lt?xml version="1.0" encoding="UTF-8"?&gt 
</code></pre>

<p>Elle indique la version de XML à utilisé, ainsi que l'encodage du fichier.</p>

<h2>Root</h2>
<hr/>
l'élément décrit est notre élément racine.
Il est unique, on ne peut donc en déclarer <b>1</b> seul par fichier.
<pre><code>
&ltlivre&gt 
 ...
&lt/livre&gt 
 </code></pre>
<p>C'est à l'intérieur de cette balise que l'on va définir notre information avec des éléments.</p>

<h2>Commentaires</h2>
<hr/>

<p>
 la syntaxe est équivalente à celle du HTML:
  <pre><code>
   &lt!-- Ceci est un commentaire --&gt
 </code></pre>
</p> 

<h2>Elements</h2>
<hr/>
<p>Un élément peut contenir:
 <ul>
   <li>Une information :
<pre><code>&ltNOM_ELEMENT&gt information  &lt/NOM_ELEMENT&gt</code></pre>
</li>
   <li>Un autre élément :
<pre><code> &ltNOM_ELEM_PARENT&gt
   &ltNOM_ELEM_ENFANT&gt 
   ...
   &lt/NOM_ELEM_ENFANT&gt
&lt/NOM_ELEM_PARENT&gt</code></pre>
  </li>
  <li>Un attribut :
 <pre><code>&ltNOM_ELEMENT <i>NOM_ATTRIBUT="attribut"</i> &gt ...  &lt/NOM_ELEMENT&gt</code></pre></li>
  <li>Un mix des 3:
  <pre><code> 
   &ltlivre lang="fr"&gt
     &lttitre&gt 
        Le cycle de fondation
      &lt/titre&gt
    &lt/livre&gt
</code></pre>
</li>
	<li>Rien :
 <pre><code> 
   &lt;livre/&gt;
</code></pre>

	</li>
</ul>
</p>
<h3>Remarques </h3>
<hr/>
<ul>
 <li>tous les éléments d'une information <b>DOIVENT</b> être enfant (incluse) de l'élement racine (root).</li>
 <li>Tous les éléments <b>DOIVENT</b> être fermées</li>
 <li>XML est sensible à la case:  &lt letter &gt != &ltletter&gt != &ltLetter&gt</li>
<li>Un élément peut posséder 0,1 ou plusieurs attributs.</li>
<li>Un nom d'élément doit commencer par une lettre mais pas avec "xml","XML,"Xml".</li>
<li>Les espaces, tabulations et retour à la ligne sont conservées </li>
  <li>5 caractères sont réservés: </li>
</ul>
 <table class="table">
 <tbody>
  <tr>
   <th scop="row">1</th>
   <td>&amp;lt; </td>
   <td> < </td>
  </tr>
   <tr>
   <th scop="row">2</th>
   <td>&amp;lt;</td>
   <td>&gt</td>
  </tr>
  <tr>
   <th scop="row">3</th>
   <td>&amp;amp;</td>
   <td>&</td>
  </tr> 
  <tr>
   <th scop="row">4</th>
   <td>&amp;apos;</td>
   <td>'</td>
  </tr> 
  <tr>
   <th scop="row">5</th>
   <td>&amp;quot;</td>
   <td>"</td>
  </tr> 
  </tbody>
 <tr/>
</table>
 <p>Il faut donc utiliser la version text pour qu'ils soient correctement interprétés</p>

<p>Ou bien utiliser les Sections Littérales (CDATA)</p>

<pre><code>
  &lt;conversionData&gt;
   &lt;![CDATA[
   1 kilometer &lt; 1 mile
   1 pound &lt; 1 kilogram 
   ]]&gt;
  &lt;/conversionData&gt;
 </code></pre>

<h3>Bonnes pratiques</h3>
<hr/>
<ul>
  <li>Donner des noms court et explicite</li>
  <li>Eviter les caractères "-","." </li>
  <li>Utiliser des caractères non ASCII (é,è,ç,...)
est autorisées mais risque de ne pas être correctement interprété</li>
</ul>

<h2>Attribut ou Element?</h2>
<hr/>

Pas de réponse claire... mais en règle général on évitera les attributs quand:
<ul>
  <li>L'attribut représente plusieurs valeurs</li>
  <li>L'attribut peut être représenté sous une forme arborescente</li>
  <li>L'attribut risque d'être étendu dans le futur</li>
</ul>
On préfera utiliser un attribut pour identifier un élément lui même plutôt qu'une informationde ce dernier.

<p>Avec un exemple :<br/>
 Pas bien : 
 <pre><code>
&lt;note id="42" jour="10" mois="01" année="2019"
a="John Doe" de="Moi" entete="Rappel"
msg="n'oublie pas de sortir le chat"&gt;
&lt;/note&gt; 
 </pre></code>

 Bien :
<pre><code>
&lt;note id="42"&gt;
  &lt;annee&gt;2019&lt;/annee&gt;
  &lt;mois&gt;1&lt;/mois&gt;
  &lt;jours&gt;10&lt;/jours&gt;
  &lt;de&gt;Moi&lt;/de&gt;
  &lt;a&gt;John Doe&lt;/a&gt;
  &lt;entete&gt;Rappel&lt;/entete&gt;
  &lt;message&gt;N'oublie pas de sortir le chat&lt;/message&gt;
&lt;/note&gt; 
 </pre></code>
</p>
<h2>Namespace</h2>
<hr/>
 <div class="row">
   <div class="col-12 d-flex justify-content-between" >
     <pre><code>
     &lt;note&gt;
        &lt;message&gt;Foo&lt;message&gt;
     &lt;/note&gt;


</code></pre>
     <pre><code>
     &lt;matiere&gt;
        &lt;libelle&gt;XML&lt;libelle&gt;
        &lt;note&gt;13.37&lt;note&gt;
     &lt;/matiere&gt;
    </code></pre>
   </div>
 </div>
<p>Ce fichier xml renseigne 2 éléments ayant le même nom (note), ce qui provoquera des conflits.
<br/>
Pour empêcher ce problème, on défini des espaces de noms <i>(namespace)</i>:<br/>
Ils sont généralement déclaré dans l'éléménet racine avec l'attribut <em>xmlns</em>.
</p>
<pre><code>
   &lt;root
    xmlns:m="https://www.foo.com/notes/"
    xmlns:n="https://www.bar.com/matiere/" &gt;
     &lt;m:note&gt;
       &lt;m:message&gt;Foo&lt;/m:message&gt;
     &lt;/m:note&gt;

     &lt;n:matiere&gt;
       &lt;n:libelle&gt;XML&lt;/n:libelle&gt;
       &lt;n:note&gt;13.37&lt;/n:valeur&gt;
     &lt;/n:matiere&gt;
   &lt;/root&gt;
  </code></pre>

<div class="row">
 <div class="col-12 d-flex justify-content-between" >
   <a href="/teaching/xml/introduction"class="btn btn-primary" role="button" >Introduction </a> <a href="/teaching"class="btn btn-primary" role="button" >Sommaire </a>  <a href="/teaching/xml/dtd"class="btn btn-primary" role="button" >DTD</a>
 </div>
</div>


